/usr/lib/news/bin/news.daily is in inn 1:1.7.2q-44+b2.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 | #! /bin/sh
## $Revision: 1.34 $
## Daily news maintenance.
## Optional arguments:
## expdir=xxx Directory in which to build new history file
## expirectl=xxx Use xxx as expire.ctl file
## flags=xxx Pass xxx flags to expire
## noexpire Do not expire
## noexplog Do not log expire output
## nologs Do not scan logfiles
## nomail Do not capture and mail output
## norenumber Do not renumber the active file
## norm Do not remove certain old files
## norotate Do not rotate logfiles
## nostat Do not run innstat
## notdaily Not a daily run, and therefore implies nologs.
## delayrm Delay unlink files, then do it quicker (expire -z)
## /full/path Path to a program to run before expiring
## =()<. @<_PATH_SHELLVARS>@>()=
. /usr/lib/news/innshellvars
EXPLOG=${MOST_LOGS}/expire.log
INNSTAT=${NEWSBIN}/innstat
HOSTNAME=`hostname`
DATE=`date`
## If your expire does not pause or throttle innd, enable this next line:
#MESSAGE="Expiration script $$"
## Renumber all at once, or in steps? Set to the delay if steps (that
## may take a long time!).
RENUMBER=
PROGNAME=news.daily
LOCK=${LOCKS}/LOCK.${PROGNAME}
## Set defaults.
DAILY=true
DOEXPIRE=true
DOEXPLOG=true
DOEXPIREOVER=false
DOLOGS=true
DOMAIL=true
DORENUMBER=true
DORM=true
DOSTAT=true
EXPIRECTL=
EXPDIR=
EXPIREFLAGS="-v1"
EXPIREOVERFLAGS=
PROGRAMS=
REASON=
RMFILE=
SCANARG=
## Parse JCL.
for I
do
case "X$I" in
Xdelayrm)
RMFILE=${MOST_LOGS}/expire.rm
;;
Xexpctl=*)
EXPIRECTL=`expr "${I}" : 'expctl=\(.*\)'`
case ${EXPIRECTL} in
/*)
;;
*)
EXPIRECTL=`/bin/pwd`/${EXPIRECTL}
;;
esac
;;
Xexpdir=*)
EXPDIR=`expr "${I}" : 'expdir=\(.*\)'`
;;
Xexpireover)
DOEXPIREOVER=true
;;
Xexpireoverflags=*)
EXPIREOVERFLAGS=`expr "${I}" : 'expireoverflags=\(.*\)'`
;;
Xflags=*)
EXPIREFLAGS=`expr "${I}" : 'flags=\(.*\)'`
;;
Xnotdaily)
DAILY=false
DOLOGS=false
;;
Xnoexpire)
DOEXPIRE=false
;;
Xnoexplog)
DOEXPLOG=false
;;
Xnologs)
DOLOGS=false
;;
Xnomail)
DOMAIL=false
MAIL=cat
;;
Xnonn)
# Ignore this.
;;
Xnorenumber)
DORENUMBER=false
;;
Xnorm)
DORM=false
;;
Xnorotate)
SCANARG="${SCANARG} norotate"
;;
Xnostat)
DOSTAT=false
;;
X/*)
PROGRAMS="${PROGRAMS} ${I}"
;;
*)
echo "Unknown flag ${I}" 1>&2
exit 1
;;
esac
done
##
## Setup mail subject
##
if ${DAILY} ; then
MAILSUBJ="${HOSTNAME} daily usenet report for ${DATE}"
else
MAILSUBJ="${HOSTNAME} intermediate usenet report for ${DATE}"
fi
MAIL="${MAILCMD} -s \"FAILED: ${MAILSUBJ}\" ${NEWSMASTER}"
${DOEXPIRE} || {
EXPDIR=
RMFILE=
}
test -n "${EXPDIR}" && {
test -z "${REASON}" && REASON="Expiring $$ on ${EXPDIR}"
EXPIREFLAGS="${EXPIREFLAGS} '-d${EXPDIR}' '-r${REASON}'"
}
test -n "${RMFILE}" && {
EXPIREFLAGS="${EXPIREFLAGS} -z${RMFILE}"
EXPIREOVERFLAGS="${EXPIREOVERFLAGS} -z ${RMFILE}.$$"
}
test -z "${EXPIREOVERFLAGS}" && EXPIREOVERFLAGS=-s
if ${DOMAIL} ; then
## Try to get a temporary file.
TEMP=${TMPDIR}/doex$$
test -f ${TEMP} && {
MAIL="${MAILCMD} -s \"${HOSTNAME}: Delayed USENET report\" ${NEWSMASTER}"
echo "Temporary file ${TEMP} exists" | eval ${MAIL}
exit 1
}
touch ${TEMP}
chmod 0660 ${TEMP}
exec 3>&1 >${TEMP} 2>&1
fi
cd ${NEWSLIB}
## Show the status of the news system.
${DOSTAT} && {
${INNSTAT}
echo ''
}
## Lock out others.
trap 'rm -f ${LOCK} ; exit 1' 1 2 3 15
shlock -p $$ -f ${LOCK} || {
( echo "$0: Locked by `cat ${LOCK}`"; ${INNSTAT} ) | eval ${MAIL}
exit 1
}
## Run any user programs.
if [ -n "${PROGRAMS}" ] ; then
for P in ${PROGRAMS} ; do
echo ''
echo "${P}:"
eval ${P}
done
fi
## The heart of the matter: prologs, expire, epilogs.
if ${DOEXPIRE} ; then
## Wait to be fairly certain innwatch is not in the middle of a pass
## Since we're locked, innwatch will pause now till we're done
sleep 30
## See if we're throttled for lack of space.
SERVERMODE=`ctlinnd mode 2>/dev/null | ${SED} 1q`
case "${SERVERMODE}" in
'Server paused'*'[innwatch:'*)
## If paused, by innwatch, then turn pause into throttle
## as we're going to stay that way for a while now
ctlinnd -s throttle "`expr \"${SERVERMODE}\" : 'Server paused \(.*\)'`"
esac
case "${SERVERMODE}" in
*space*" -- throttling")
echo "${SERVERMODE} -- trying to recover"
THROTTLED=true
EXPIREFLAGS="${EXPIREFLAGS} -n"
MESSAGE=
;;
*"[innwatch:"*)
echo "${SERVERMODE} -- pressing on"
THROTTLED=false
EXPIREFLAGS="${EXPIREFLAGS} -n"
MESSAGE=
DORENUMBER=false
;;
*)
THROTTLED=false
;;
esac
## Throttle server if we need to.
if [ -n "${MESSAGE}" ] ; then
ctlinnd -s -t120 throttle "${MESSAGE}" 2>&1 || {
( echo "$0: Cannot throttle news"; ${INNSTAT} ) | eval ${MAIL}
exit 1
}
fi
#
# Get rid of an old expire RMFILE since news.daily locks itself and
# we would not get here if another instance were still running.
#
if [ -n "${RMFILE}" ] ; then
rm -f ${RMFILE}
fi
## Actual expire the articles (finally!).
test -n "${EXPIRECTL}" && EXPIREFLAGS="${EXPIREFLAGS} ${EXPIRECTL}"
if ${DOEXPLOG}; then
echo "expire begin `date`: (${EXPIREFLAGS})" >>${EXPLOG}
( exec 2>&1 ; eval expire "${EXPIREFLAGS}" ) \
| ${SED} -e 's/^/ /' >>${EXPLOG}
echo "expire end `date`" >>${EXPLOG}
else
eval expire "${EXPIREFLAGS}"
fi
## If built on another filesystem, move history files.
if [ -n "${EXPDIR}" ] ; then
if [ ! -f ${EXPDIR}/history.n -o ! -f ${EXPDIR}/history.n.done ] ; then
( echo "$0: No new history files"; ${INNSTAT} ) | eval ${MAIL}
exit 1
fi
mv -f ${EXPDIR}/history.n ${HISTORY}
mv -f ${EXPDIR}/history.n.dir ${HISTORY}.dir
mv -f ${EXPDIR}/history.n.pag ${HISTORY}.pag
rm -f ${EXPDIR}/history.n.done
case "${EXPIREFLAGS}" in
*-n*)
;;
*)
MESSAGE="${REASON}"
;;
esac
fi
## Restart the server if we need to.
if ${THROTTLED} || test -n "${MESSAGE}" ; then
ctlinnd -s go "${MESSAGE}" 2>&1 || {
( echo "$0: Cannot unthrottle news"; ${INNSTAT} ) | eval ${MAIL}
exit 1
}
fi
fi
${DOLOGS} && {
echo ''
scanlogs ${SCANARG}
}
## Remove old sockets.
${DORM} &&
find ${TEMPSOCKDIR} -name "${TEMPSOCK}" -mtime +2 -exec rm -f '{}' ';'
## Did we became throttled during the run?
SERVERMODE=`ctlinnd mode 2>/dev/null | ${SED} 1q`
case "${SERVERMODE}" in
*space*" -- throttling")
## We did, try to unthrottle the server.
echo "${SERVERMODE} -- trying to recover"
ctlinnd -s go ""
;;
esac
## Show the status of the news system after expiration.
${DOSTAT} && {
echo 'Post expiration status:' ; echo ''
${INNSTAT}
echo ''
}
## Release the lock now, everything below this must be able to withstand
## simultaneous news.daily's running. We do this so innwatch can start
## monitoring again asap after the expire is done -- removing the
## articles isn't critical, nor is the renumber.
rm ${LOCK}
## Remove the articles that are supposed to go
if ${DOEXPIRE} ; then
test -n "${RMFILE}" -a -s "${RMFILE}" && {
mv ${RMFILE} ${RMFILE}.$$ && RMFILE=${RMFILE}.$$
test -n "${TMPDIR}" && T="-T ${TMPDIR}"
sort -u -o ${RMFILE} ${RMFILE}
${DOEXPIREOVER} && {
eval expireover "${EXPIREOVERFLAGS}"
DOEXPIREOVER=false
}
expirerm ${RMFILE}
}
${DOEXPIREOVER} && eval expireover "${EXPIREOVERFLAGS}"
fi
## Renumber the active file.
if ${DORENUMBER} ; then
echo ''
echo 'Renumbering active file.'
if [ -z "${RENUMBER}" ] ;then
ctlinnd -s -t`wc -l <${ACTIVE}` renumber '' 2>&1
else
while read GROUP hi lo flag ; do
ctlinnd -s renumber ${GROUP} 2>&1
sleep ${RENUMBER}
done <${ACTIVE}
fi
fi
## Mail the report.
if ${DOMAIL} ; then
# Stop using the temp file, and mail captured output.
exec 1>&3 2>&1 3>&-
MAIL="${MAILCMD} -s \"${MAILSUBJ}\" ${NEWSMASTER}"
test -s ${TEMP} && cat ${TEMP} | sed -e 's/^~/~~/' | eval ${MAIL}
rm -f ${TEMP}
fi
## All done
if ${DAILY} ; then
date >${NEWSLIB}/.news.daily
fi
${RNEWS} -U
exit 0
|